routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use App\Models\Practica;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

// enrutamiento para controlador alumno
Route::resource('alumno', AlumnoController::class);

// enrutamiento para controlador curso
Route::resource('curso', CursoController::class);

// enrutamiento para todo
Route::resource('practica', PracticaController::class);
Route::resource('presenta', PresentaController::class);
Route::resource('pertenece', PerteneceController::class);

// enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('/practica/confirmar/{practica}', 'confirmar')->name('practica.confirmar');
});

// enrutamiento adicional para pertenece
Route::controller(PerteneceController::class)->group(function () {
    Route::get('/pertenece/confirmar/{pertenece}', 'confirmar')->name('pertenece.confirmar');
});

app/Models/Pertenece.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Pertenece extends Model
{
    use HasFactory;
    // nombre de la tabla
    protected $table = 'perteneces';

    // campos de asignacion masiva
    protected $fillable = [
        'alumno_id', 'curso_id'
    ];

    // creamos un atributo estatico con los labels
    public static $labels = [
        'id' => 'ID',
        'alumno_id' => 'Id del Alumno',
        'curso_id' => 'Id del Curso',
    ];

    // metodo para devolver el label de un campo
    public function getAttributeLabel($key)
    {
        return self::$labels[$key] ?? $key;
    }

    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }

    // voy a crear las relaciones

    public function alumno(): BelongsTo
    {
        return $this->belongsTo(Alumno::class, 'alumno_id');
    }

    public function curso(): BelongsTo
    {
        return $this->belongsTo(Curso::class, 'curso_id');
    }
}

app/Http/Controllers/PerteneceController.php
<?php

namespace App\Http\Controllers;

use App\Models\Alumno;
use App\Models\Curso;
use App\Models\Pertenece;
use Illuminate\Http\Request;

class PerteneceController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $perteneces = Pertenece::all();

        return view(
            'pertenece.index',
            compact('perteneces')
        );
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        // esto es para el dropdown
        $alumnos = Alumno::all();
        $cursos = Curso::all();

        return view('pertenece.create', compact('alumnos', 'cursos'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $pertenece = Pertenece::create($request->all());

        return redirect()
            ->route('pertenece.show', $pertenece);
    }

    /**
     * Display the specified resource.
     */
    public function show(Pertenece $pertenece)
    {
        return view(
            'pertenece.show',
            compact('pertenece')
        );
    }

    /**r
     * Show the form for editing the specified resource.
     */
    public function edit(Pertenece $pertenece)
    {
        // esto es para el dropdown
        $alumnos = Alumno::all();
        $cursos = Curso::all();

        return view(
            'pertenece.edit',
            compact('pertenece', 'alumnos', 'cursos')
        );
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Pertenece $pertenece)
    {
        $pertenece->update($request->all());

        return redirect()
            ->route('pertenece.show', $pertenece);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Pertenece $pertenece)
    {
        $pertenece->delete();

        return redirect()
            ->route('pertenece.index');
    }

    public function confirmar(Pertenece $pertenece)
    {
        return view('pertenece.confirmar', compact('pertenece'));
    }
}

resources/views/pertenece/confirmar.blade.php
@extends('layouts.main')

@section('content')
    <h1>Eliminando registro</h1>
    <div>
        ¿Estas seguro de que quieres borrar el registro?
    </div>
    <div class="tarjeta">
        <ul>
            <li>id:{{ $pertenece->id }}</li>
            <li>Alumno:{{ $pertenece->alumno_id }} - {{ $pertenece->alumno->nombre }}</li>
            <li>Curso:{{ $pertenece->curso_id }} - {{ $pertenece->curso->nombre }}</li>
        </ul>
        <form action="{{ route('pertenece.destroy', $pertenece) }}" method="post" class="form-inline">
            @csrf
            @method('delete')
            <button type="submit" class="boton">Borrar</button>
        </form>
    </div>
@endsection

resources/views/pertenece/create.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <form action="{{ route('pertenece.store') }}" method="post" enctype="multipart/form-data">
            @csrf
            <div>
                <label>Curso</label>
                <select name="curso_id">
                    @foreach ($cursos as $curso)
                        <option value="{{ $curso->id }}">{{ $curso->nombre }}</option>
                    @endforeach
                </select>
            </div>
            <div>
                <label>Alumno</label>
                <select name="alumno_id">
                    @foreach ($alumnos as $alumno)
                        <option value="{{ $alumno->id }}">{{ $alumno->nombre }}</option>
                    @endforeach
                </select>
            </div>

            <div>
                <button type="submit" class="boton">Enviar</button>
            </div>
        </form>
    </div>
@endSection

resources/views/pertenece/edit.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <form action="{{ route('pertenece.update', $pertenece) }}" method="post" enctype="multipart/form-data">
            @csrf
            @method('put')
            <div>
                <label>Curso</label>
                <select name="curso_id">
                    @foreach ($cursos as $curso)
                        <option value="{{ $curso->id }}" {{ $pertenece->curso_id == $curso->id ? 'selected' : '' }}>
                            {{ $curso->nombre }}</option>
                    @endforeach
                </select>
            </div>
            <div>
                <label>Alumno</label>
                <select name="alumno_id">
                    @foreach ($alumnos as $alumno)
                        <option value="{{ $alumno->id }}" {{ $pertenece->alumno_id == $alumno->id ? 'selected' : '' }}>
                            {{ $alumno->nombre }}</option>
                    @endforeach
                </select>
            </div>

            <div>
                <button type="submit" class="boton">Enviar</button>
            </div>
        </form>
    </div>
@endSection

resources/views/pertenece/index.blade.php
@extends('layouts.main')

@section('content')
    <div class="listado">
        @foreach ($perteneces as $pertenece)
            <div class="tarjeta">
                <ul>
                    <li>id:{{ $pertenece->id }}</li>
                    <li>Alumno:{{ $pertenece->alumno_id }} - {{ $pertenece->alumno->nombre }}</li>
                    <li>Curso:{{ $pertenece->curso_id }} - {{ $pertenece->curso->nombre }}</li>
                </ul>
                <div class="botones">
                    <a href="{{ route('pertenece.show', $pertenece) }}" class="boton">Ver</a>
                    <a href="{{ route('pertenece.edit', $pertenece) }}" class="boton">Actualizar</a>
                    <form action="{{ route('pertenece.destroy', $pertenece) }}" method="post" id="eliminar"
                        class="form-inline">
                        @csrf
                        @method('delete')
                        <button type="submit" class="boton">Borrar</button>
                    </form>
                    <a href="{{ route('pertenece.confirmar', $pertenece) }}" class="boton">Eliminar de otra forma</a>
                </div>
            </div>
        @endforeach
    </div>
@endsection

resources/views/pertenece/show.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <ul>
            <li>id:{{ $pertenece->id }}</li>
            <li>Titulo:{{ $pertenece->alumno_id }} - {{ $pertenece->alumno->nombre }}</li>
            <li>Curso:{{ $pertenece->curso_id }} - {{ $pertenece->curso->nombre }}</li>
        </ul>
        <div class="botones">
            <a href="{{ route('pertenece.edit', $pertenece) }}" class="boton">Actualizar</a>
            <form action="{{ route('pertenece.destroy', $pertenece) }}" method="post" id="eliminar" class="form-inline">
                @csrf
                @method('delete')
                <button type="submit" class="boton">Borrar</button>
            </form>
            <a href="{{ route('pertenece.confirmar', $pertenece) }}" class="boton">Eliminar otra forma</a>
        </div>
    </div>
@endsection